<?php

namespace Pepitelabs\PWS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetServicesOptionsRequestContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\GetServicesOptionsRequestContainer',
            'RequestContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\RequestContainer',
            'ShortAddress' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ShortAddress',
            'RequestContext' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\RequestContext',
            'GetServicesOptionsResponseContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\GetServicesOptionsResponseContainer',
            'ResponseContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ResponseContainer',
            'ResponseInformation' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ResponseInformation',
            'ArrayOfError' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfError',
            'Error' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\Error',
            'ArrayOfInformationalMessage' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfInformationalMessage',
            'InformationalMessage' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\InformationalMessage',
            'ArrayOfService' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfService',
            'Service' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\Service',
            'ArrayOfOption' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfOption',
            'Option' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\Option',
            'ArrayOfOptionValue' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfOptionValue',
            'OptionValue' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\OptionValue',
            'ResponseContext' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ResponseContext',
            'GetServiceRulesRequestContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\GetServiceRulesRequestContainer',
            'GetServiceRulesResponseContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\GetServiceRulesResponseContainer',
            'ArrayOfServiceRule' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfServiceRule',
            'ServiceRule' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ServiceRule',
            'Weight' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\Weight',
            'Dimension' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\Dimension',
            'ArrayOfServiceOptionRules' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfServiceOptionRules',
            'ServiceOptionRules' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ServiceOptionRules',
            'ArrayOfOptionIDValuePair' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfOptionIDValuePair',
            'OptionIDValuePair' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\OptionIDValuePair',
            'ArrayOfOptionRule' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfOptionRule',
            'OptionRule' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\OptionRule',
            'ValidateCityPostalCodeZipRequestContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ValidateCityPostalCodeZipRequestContainer',
            'ArrayOfShortAddress' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfShortAddress',
            'ValidateCityPostalCodeZipResponseContainer' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ValidateCityPostalCodeZipResponseContainer',
            'ArrayOfSuggestedAddress' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfSuggestedAddress',
            'SuggestedAddress' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\SuggestedAddress',
            'ValidationFault' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ValidationFault',
            'ArrayOfValidationDetail' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ArrayOfValidationDetail',
            'ValidationDetail' => '\\Pepitelabs\\PWS\\ServiceAvailabilityService\\ValidationDetail',
        );
    }
}
