<?php

namespace Pepitelabs\PWS\ServiceAvailabilityService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOptionValue ServiceAvailabilityService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOptionValue
 * @subpackage Arrays
 */
class ArrayOfOptionValue extends AbstractStructArrayBase
{
    /**
     * The OptionValue
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue[]
     */
    public $OptionValue;
    /**
     * Constructor method for ArrayOfOptionValue
     * @uses ArrayOfOptionValue::setOptionValue()
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue[] $optionValue
     */
    public function __construct(array $optionValue = array())
    {
        $this
            ->setOptionValue($optionValue);
    }
    /**
     * Get OptionValue value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue[]|null
     */
    public function getOptionValue()
    {
        return isset($this->OptionValue) ? $this->OptionValue : null;
    }
    /**
     * This method is responsible for validating the values passed to the setOptionValue method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOptionValue method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOptionValueForArrayConstraintsFromSetOptionValue(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfOptionValueOptionValueItem) {
            // validation for constraint: itemType
            if (!$arrayOfOptionValueOptionValueItem instanceof \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue) {
                $invalidValues[] = is_object($arrayOfOptionValueOptionValueItem) ? get_class($arrayOfOptionValueOptionValueItem) : sprintf('%s(%s)', gettype($arrayOfOptionValueOptionValueItem), var_export($arrayOfOptionValueOptionValueItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OptionValue property can only contain items of type \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OptionValue value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue[] $optionValue
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionValue
     */
    public function setOptionValue(array $optionValue = array())
    {
        // validation for constraint: array
        if ('' !== ($optionValueArrayErrorMessage = self::validateOptionValueForArrayConstraintsFromSetOptionValue($optionValue))) {
            throw new \InvalidArgumentException($optionValueArrayErrorMessage, __LINE__);
        }
        if (is_null($optionValue) || (is_array($optionValue) && empty($optionValue))) {
            unset($this->OptionValue);
        } else {
            $this->OptionValue = $optionValue;
        }
        return $this;
    }
    /**
     * Add item to OptionValue value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue $item
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionValue
     */
    public function addToOptionValue(\Pepitelabs\PWS\ServiceAvailabilityService\OptionValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue) {
            throw new \InvalidArgumentException(sprintf('The OptionValue property can only contain items of type \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OptionValue[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionValue|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OptionValue
     */
    public function getAttributeName()
    {
        return 'OptionValue';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionValue
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
