<?php

namespace Pepitelabs\PWS\ServiceAvailabilityService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfShortAddress ServiceAvailabilityService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfShortAddress
 * @subpackage Arrays
 */
class ArrayOfShortAddress extends AbstractStructArrayBase
{
    /**
     * The ShortAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress[]
     */
    public $ShortAddress;
    /**
     * Constructor method for ArrayOfShortAddress
     * @uses ArrayOfShortAddress::setShortAddress()
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress[] $shortAddress
     */
    public function __construct(array $shortAddress = array())
    {
        $this
            ->setShortAddress($shortAddress);
    }
    /**
     * Get ShortAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress[]|null
     */
    public function getShortAddress()
    {
        return isset($this->ShortAddress) ? $this->ShortAddress : null;
    }
    /**
     * This method is responsible for validating the values passed to the setShortAddress method
     * This method is willingly generated in order to preserve the one-line inline validation within the setShortAddress method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateShortAddressForArrayConstraintsFromSetShortAddress(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfShortAddressShortAddressItem) {
            // validation for constraint: itemType
            if (!$arrayOfShortAddressShortAddressItem instanceof \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress) {
                $invalidValues[] = is_object($arrayOfShortAddressShortAddressItem) ? get_class($arrayOfShortAddressShortAddressItem) : sprintf('%s(%s)', gettype($arrayOfShortAddressShortAddressItem), var_export($arrayOfShortAddressShortAddressItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ShortAddress property can only contain items of type \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ShortAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress[] $shortAddress
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfShortAddress
     */
    public function setShortAddress(array $shortAddress = array())
    {
        // validation for constraint: array
        if ('' !== ($shortAddressArrayErrorMessage = self::validateShortAddressForArrayConstraintsFromSetShortAddress($shortAddress))) {
            throw new \InvalidArgumentException($shortAddressArrayErrorMessage, __LINE__);
        }
        if (is_null($shortAddress) || (is_array($shortAddress) && empty($shortAddress))) {
            unset($this->ShortAddress);
        } else {
            $this->ShortAddress = $shortAddress;
        }
        return $this;
    }
    /**
     * Add item to ShortAddress value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress $item
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfShortAddress
     */
    public function addToShortAddress(\Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress) {
            throw new \InvalidArgumentException(sprintf('The ShortAddress property can only contain items of type \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ShortAddress[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ShortAddress
     */
    public function getAttributeName()
    {
        return 'ShortAddress';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfShortAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
