<?php

namespace Pepitelabs\PWS\ServiceAvailabilityService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSuggestedAddress ServiceAvailabilityService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSuggestedAddress
 * @subpackage Arrays
 */
class ArrayOfSuggestedAddress extends AbstractStructArrayBase
{
    /**
     * The SuggestedAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress[]
     */
    public $SuggestedAddress;
    /**
     * Constructor method for ArrayOfSuggestedAddress
     * @uses ArrayOfSuggestedAddress::setSuggestedAddress()
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress[] $suggestedAddress
     */
    public function __construct(array $suggestedAddress = array())
    {
        $this
            ->setSuggestedAddress($suggestedAddress);
    }
    /**
     * Get SuggestedAddress value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress[]|null
     */
    public function getSuggestedAddress()
    {
        return isset($this->SuggestedAddress) ? $this->SuggestedAddress : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSuggestedAddress method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuggestedAddress method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSuggestedAddressForArrayConstraintsFromSetSuggestedAddress(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSuggestedAddressSuggestedAddressItem) {
            // validation for constraint: itemType
            if (!$arrayOfSuggestedAddressSuggestedAddressItem instanceof \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress) {
                $invalidValues[] = is_object($arrayOfSuggestedAddressSuggestedAddressItem) ? get_class($arrayOfSuggestedAddressSuggestedAddressItem) : sprintf('%s(%s)', gettype($arrayOfSuggestedAddressSuggestedAddressItem), var_export($arrayOfSuggestedAddressSuggestedAddressItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SuggestedAddress property can only contain items of type \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SuggestedAddress value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress[] $suggestedAddress
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfSuggestedAddress
     */
    public function setSuggestedAddress(array $suggestedAddress = array())
    {
        // validation for constraint: array
        if ('' !== ($suggestedAddressArrayErrorMessage = self::validateSuggestedAddressForArrayConstraintsFromSetSuggestedAddress($suggestedAddress))) {
            throw new \InvalidArgumentException($suggestedAddressArrayErrorMessage, __LINE__);
        }
        if (is_null($suggestedAddress) || (is_array($suggestedAddress) && empty($suggestedAddress))) {
            unset($this->SuggestedAddress);
        } else {
            $this->SuggestedAddress = $suggestedAddress;
        }
        return $this;
    }
    /**
     * Add item to SuggestedAddress value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress $item
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfSuggestedAddress
     */
    public function addToSuggestedAddress(\Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress) {
            throw new \InvalidArgumentException(sprintf('The SuggestedAddress property can only contain items of type \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SuggestedAddress[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SuggestedAddress
     */
    public function getAttributeName()
    {
        return 'SuggestedAddress';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfSuggestedAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
