<?php

namespace Pepitelabs\PWS\ServiceAvailabilityService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OptionRule ServiceAvailabilityService
 * Meta information extracted from the WSDL
 * - documentation: OptionRule
 * - nillable: true
 * - type: tns:OptionRule
 * @subpackage Structs
 */
class OptionRule extends AbstractStructBase
{
    /**
     * The OptionIDValuePair
     * Meta information extracted from the WSDL
     * - documentation: OptionIDValuePair - OptionIDValuePair
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\OptionIDValuePair
     */
    public $OptionIDValuePair;
    /**
     * The Exclusions
     * Meta information extracted from the WSDL
     * - documentation: Exclusions - OptionIDValuePair[]
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair
     */
    public $Exclusions;
    /**
     * The Inclusions
     * Meta information extracted from the WSDL
     * - documentation: Inclusions - OptionIDValuePair[]
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair
     */
    public $Inclusions;
    /**
     * Constructor method for OptionRule
     * @uses OptionRule::setOptionIDValuePair()
     * @uses OptionRule::setExclusions()
     * @uses OptionRule::setInclusions()
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\OptionIDValuePair $optionIDValuePair
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $exclusions
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $inclusions
     */
    public function __construct(\Pepitelabs\PWS\ServiceAvailabilityService\OptionIDValuePair $optionIDValuePair = null, \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $exclusions = null, \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $inclusions = null)
    {
        $this
            ->setOptionIDValuePair($optionIDValuePair)
            ->setExclusions($exclusions)
            ->setInclusions($inclusions);
    }
    /**
     * Get OptionIDValuePair value
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionIDValuePair|null
     */
    public function getOptionIDValuePair()
    {
        return $this->OptionIDValuePair;
    }
    /**
     * Set OptionIDValuePair value
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\OptionIDValuePair $optionIDValuePair
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionRule
     */
    public function setOptionIDValuePair(\Pepitelabs\PWS\ServiceAvailabilityService\OptionIDValuePair $optionIDValuePair = null)
    {
        $this->OptionIDValuePair = $optionIDValuePair;
        return $this;
    }
    /**
     * Get Exclusions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair|null
     */
    public function getExclusions()
    {
        return isset($this->Exclusions) ? $this->Exclusions : null;
    }
    /**
     * Set Exclusions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $exclusions
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionRule
     */
    public function setExclusions(\Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $exclusions = null)
    {
        if (is_null($exclusions) || (is_array($exclusions) && empty($exclusions))) {
            unset($this->Exclusions);
        } else {
            $this->Exclusions = $exclusions;
        }
        return $this;
    }
    /**
     * Get Inclusions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair|null
     */
    public function getInclusions()
    {
        return isset($this->Inclusions) ? $this->Inclusions : null;
    }
    /**
     * Set Inclusions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $inclusions
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionRule
     */
    public function setInclusions(\Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfOptionIDValuePair $inclusions = null)
    {
        if (is_null($inclusions) || (is_array($inclusions) && empty($inclusions))) {
            unset($this->Inclusions);
        } else {
            $this->Inclusions = $inclusions;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\OptionRule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
