<?php

namespace Pepitelabs\PWS\ServiceAvailabilityService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResponseInformation ServiceAvailabilityService
 * Meta information extracted from the WSDL
 * - documentation: ResponseInformation
 * - nillable: true
 * - type: tns:ResponseInformation
 * @subpackage Structs
 */
class ResponseInformation extends AbstractStructBase
{
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - documentation: Errors - Error[]
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfError
     */
    public $Errors;
    /**
     * The InformationalMessages
     * Meta information extracted from the WSDL
     * - documentation: InformationalMessages - InformationalMessage[]
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfInformationalMessage
     */
    public $InformationalMessages;
    /**
     * Constructor method for ResponseInformation
     * @uses ResponseInformation::setErrors()
     * @uses ResponseInformation::setInformationalMessages()
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfError $errors
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfInformationalMessage $informationalMessages
     */
    public function __construct(\Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfError $errors = null, \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfInformationalMessage $informationalMessages = null)
    {
        $this
            ->setErrors($errors)
            ->setInformationalMessages($informationalMessages);
    }
    /**
     * Get Errors value
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfError|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfError $errors
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation
     */
    public function setErrors(\Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfError $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get InformationalMessages value
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfInformationalMessage|null
     */
    public function getInformationalMessages()
    {
        return $this->InformationalMessages;
    }
    /**
     * Set InformationalMessages value
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfInformationalMessage $informationalMessages
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation
     */
    public function setInformationalMessages(\Pepitelabs\PWS\ServiceAvailabilityService\ArrayOfInformationalMessage $informationalMessages = null)
    {
        $this->InformationalMessages = $informationalMessages;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
