<?php

namespace Pepitelabs\PWS\ServiceAvailabilityService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SuggestedAddress ServiceAvailabilityService
 * Meta information extracted from the WSDL
 * - documentation: SuggestedShortAddress
 * - nillable: true
 * - type: tns:SuggestedAddress
 * @subpackage Structs
 */
class SuggestedAddress extends AbstractStructBase
{
    /**
     * The Address
     * Meta information extracted from the WSDL
     * - documentation: SuggestedAddress - ShortAddress
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress
     */
    public $Address;
    /**
     * The ResponseInformation
     * Meta information extracted from the WSDL
     * - documentation: ResponseInformation - ResponseInformation
     * - nillable: true
     * @var \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation
     */
    public $ResponseInformation;
    /**
     * Constructor method for SuggestedAddress
     * @uses SuggestedAddress::setAddress()
     * @uses SuggestedAddress::setResponseInformation()
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress $address
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation $responseInformation
     */
    public function __construct(\Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress $address = null, \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation $responseInformation = null)
    {
        $this
            ->setAddress($address)
            ->setResponseInformation($responseInformation);
    }
    /**
     * Get Address value
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress $address
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress
     */
    public function setAddress(\Pepitelabs\PWS\ServiceAvailabilityService\ShortAddress $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get ResponseInformation value
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation|null
     */
    public function getResponseInformation()
    {
        return $this->ResponseInformation;
    }
    /**
     * Set ResponseInformation value
     * @param \Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation $responseInformation
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress
     */
    public function setResponseInformation(\Pepitelabs\PWS\ServiceAvailabilityService\ResponseInformation $responseInformation = null)
    {
        $this->ResponseInformation = $responseInformation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ServiceAvailabilityService\SuggestedAddress
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
